#version 330

in vec4 in_Position;
in vec2 in_TextCord;


out vec2 ex_TextCord;
out vec3 ex_LightDirection_tangentspace ;
out vec3 ex_CamDirection_tangentspace  ;


uniform mat4 ModelMatrix;
uniform mat4 ViewMatrix;
uniform mat4 ProjectionMatrix;
uniform vec3 lightWorldPos;
uniform vec3 camWorldPos;

void main(void)
{
	gl_Position = (ProjectionMatrix * ViewMatrix * ModelMatrix) * in_Position;
	vec3 worldPos=(ModelMatrix*in_Position).xyz;  
	vec3 lightDirection = lightWorldPos-worldPos;
	vec3 camDirection = camWorldPos-worldPos;
	mat3 TNB=transpose(mat3(ViewMatrix));
	ex_LightDirection_tangentspace = TNB*lightDirection;
	ex_CamDirection_tangentspace  = TNB*camDirection;	
	ex_TextCord=in_TextCord;
	
}
